#include <iostream>

//-----------------------------------------------------------------------------

class Print
{
    private:
    protected:
    public:
        int m_NumberOfTimesPrinted;

        Print() //Constructor
        {
            m_NumberOfTimesPrinted = 0;
        }

        virtual void printHello();
        virtual void printGoodBye();
        virtual void printDunno();
};

void Print::printHello()
{
    std::cout << "Hello\n";
    m_NumberOfTimesPrinted++;
}

void Print::printGoodBye()
{
    std::cout << "GoodBye\n";
    m_NumberOfTimesPrinted++;
}

void Print::printDunno()
{
    std::cout << "Dunno\n";
    m_NumberOfTimesPrinted++;
}

//-----------------------------------------------------------------------------


//Derived from standard print class to add extra features
class SuperPrinter : public Print
{
    private:
    protected:
    public:

        virtual void printHello();
        virtual void printGoodBye();
        virtual void printDunno();
};

void SuperPrinter::printHello()
{
    std::cout << "Super Hello\n";
    m_NumberOfTimesPrinted++;
}

void SuperPrinter::printGoodBye()
{
    std::cout << "Super GoodBye\n";
    m_NumberOfTimesPrinted++;
}

void SuperPrinter::printDunno()
{
    std::cout << "Super Dunno\n";
    m_NumberOfTimesPrinted++;
}

//-----------------------------------------------------------------------------

int main()
{
    SuperPrinter Text;
    Print *pointer = &Text;

    pointer->printHello();
    pointer->printDunno();
    pointer->printGoodBye();

    std::cout << Text.m_NumberOfTimesPrinted;

    char key = 0;
	std::cin >> key;
    return 0;
}
