//---------------------------------------------------------------------------

CL_SceneObject::CL_SceneObject(const std::string& resource_id, CL_ResourceManager* manager,
							   float x, float y, bool visible) : CL_Sprite(resource_id, manager)
{
	init(resource_id, x, y, visible);
}

//---------------------------------------------------------------------------

void CL_SceneObject::init(const std::string& resource_id, float x, float y, bool visible)
{
	m_Position = CL_Vector2(x,y);
	m_bVisible = visible;
	m_Name = resource_id;
	m_Data = NULL;
}
